part of '../../../messages.dart';

class Balance extends Decoding {
  String id;
  String accountId;

  /// Currency code (ISO 4217)
  String currency;
  Decimal amount;
  DateTime createdAt;
  DateTime updatedAt;

  @override
  void decode(KeyedArchive object) {
    super.decode(object);
    id = object.decode('id');
    accountId = object.decode('account_id');
    currency = object.decode('currency');
    amount = decimalParse(object.decode('amount'));
    createdAt = dateTimeParse(object.decode('created_at'));
    updatedAt = dateTimeParse(object.decode('updated_at'));
  }
}
