part of '../../../messages.dart';

class Rate extends Decoding {
  DateTime settlementCutOffTime;
  String currencyPair;

  /// Currency code (ISO 4217)
  String clientBuyCurrency;

  /// Currency code (ISO 4217)
  String clientSellCurrency;
  Decimal clientBuyAmount;
  Decimal clientSellAmount;
  FixedSide fixedSide;
  Decimal clientRate;
  Decimal partnerRate;
  Decimal coreRate;
  bool depositRequired;
  Decimal depositAmount;

  /// Currency code (ISO 4217)
  String depositCurrency;
  Decimal midMarketRate;

  @override
  void decode(KeyedArchive object) {
    super.decode(object);
    settlementCutOffTime = dateTimeParse(object.decode('settlement_cut_off_time'));
    currencyPair = object.decode('currency_pair');
    clientBuyCurrency = object.decode('client_buy_currency');
    clientSellCurrency = object.decode('client_sell_currency');
    clientSellCurrency = object.decode('client_sell_currency');
    clientBuyAmount = decimalParse(object.decode('client_buy_amount'));
    clientSellAmount = decimalParse(object.decode('client_sell_amount'));
    fixedSide = FixedSide.fromString(object.decode('fixed_side'));
    clientRate = decimalParse(object.decode('client_rate'));
    partnerRate = decimalParse(object.decode('partner_rate'));
    coreRate = decimalParse(object.decode('core_rate'));
    depositRequired = object.decode('deposit_required');
    depositAmount = decimalParse(object.decode('deposit_amount'));
    depositCurrency = object.decode('deposit_currency');
    midMarketRate = decimalParse(object.decode('mid_market_rate'));
  }
}
