part of currency_cloud;

class RatesApi extends CurrencyCloudApi {
  RatesApi(CurrencyCloudClient client) : super(client);

  Future<Rate> detailed({
    @required String buyCurrency,
    @required String sellCurrency,
    @required FixedSide fixedSide,
    @required Decimal amount,
    String onBehalfOf,
    DateTime conversionDate,
  }) async {
    final json = await client.get('/rates/detailed', body: {
      'buy_currency': buyCurrency,
      'sell_currency': sellCurrency,
      'fixed_side': fixedSide.id,
      'amount': amount.toString(),
      'on_behalf_of': onBehalfOf,
      'conversionDate': conversionDate?.toString(),
    });
    return Rate()..decode(KeyedArchive.unarchive(json));
  }
}
