part of currency_cloud;

class ReferenceDataApi extends CurrencyCloudApi {
  ReferenceDataApi(CurrencyCloudClient client) : super(client);

  /// Returns required beneficiary details and their basic validation formats
  /// [currency] is the currency code (ISO 4217) of the beneficiary bank account
  /// [bankAccountCountry] is the country of the beneficiary bank account
  /// [beneficiaryCountry] is the nationality of the beneficiary
  Future<Map<String, String>> beneficiaryRequiredDetails(
      {String currency, String bankAccountCountry, String beneficiaryCountry}) async {
    var uri = '/reference/beneficiary_required_details';
    var body = <String, String>{};
    if (currency != null) body['currency'] = currency;
    if (bankAccountCountry != null) body['bank_account_country'] = bankAccountCountry;
    if (beneficiaryCountry != null) body['beneficiary_country'] = beneficiaryCountry;
    if (body.isEmpty) {
      return (await client.get(uri)).cast<String, String>();
    } else {
      return (await client.get(uri, body: body)).cast<String, String>();
    }
  }
}
