class BankAccountType {
  static const checkings = const BankAccountType._('checkings');

  static const savings = const BankAccountType._('savings');
  static List<BankAccountType> values = [checkings, savings];

  final String id;

  const BankAccountType._(this.id);

  @override
  String toString() => 'BankAccountType.$id';

  static BankAccountType fromString(String value) => value == null
      ? null
      : values.firstWhere((type) => type.id == value,
          orElse: () => throw new Exception('The type $value does not exist.'));
}

class EntityType {
  static const individual = const EntityType._('individual');

  static const company = const EntityType._('company');
  static List<EntityType> values = [individual, company];

  final String id;

  const EntityType._(this.id);

  @override
  String toString() => 'BeneficiaryEntityType.$id';

  static EntityType fromString(String value) => value == null
      ? null
      : values.firstWhere((type) => type.id == value,
          orElse: () => throw new Exception('The type $value does not exist.'));
}

class IdentificationType {
  static const none = const IdentificationType._('none');
  static const driversLicense = const IdentificationType._('drivers_license');
  static const socialSecurityNumber = const IdentificationType._('social_security_number');
  static const greenCard = const IdentificationType._('green_card');
  static const passport = const IdentificationType._('passport');
  static const visa = const IdentificationType._('visa');
  static const matriculaConsular = const IdentificationType._('matricula_consular');
  static const registroFederalDeContribuyentes = const IdentificationType._('registro_federal_de_contribuyentes');
  static const claveUnicaDeRegistroDePoblacion = const IdentificationType._('clave_unica_de_registro_de_poblacion');
  static const credentialDeElector = const IdentificationType._('credential_de_elector');
  static const socialInsuranceNumber = const IdentificationType._('social_insurance_number');
  static const citizenshipPapers = const IdentificationType._('citizenship_papers');
  static const driversLicenseCanadian = const IdentificationType._('drivers_license_canadian');
  static const existingCreditCardDetails = const IdentificationType._('existing_credit_card_details');
  static const employerIdentificationNumber = const IdentificationType._('employer_identification_number');
  static const nationalId = const IdentificationType._('national_id');
  static const incorporationNumber = const IdentificationType._('incorporation_number');
  static const others = const IdentificationType._('others');

  static List<IdentificationType> values = [
    none,
    driversLicense,
    socialSecurityNumber,
    greenCard,
    passport,
    visa,
    matriculaConsular,
    registroFederalDeContribuyentes,
    claveUnicaDeRegistroDePoblacion,
    credentialDeElector,
    socialInsuranceNumber,
    citizenshipPapers,
    driversLicenseCanadian,
    existingCreditCardDetails,
    employerIdentificationNumber,
    nationalId,
    incorporationNumber,
    others,
  ];

  final String id;

  const IdentificationType._(this.id);

  @override
  String toString() => 'BeneficiaryIdentificationType.$id';

  static IdentificationType fromString(String value) => value == null
      ? null
      : values.firstWhere((type) => type.id == value,
          orElse: () => throw new Exception('The type $value does not exist.'));
}

class FixedSide {
  static const buy = const FixedSide._('buy');

  static const sell = const FixedSide._('sell');
  static List<FixedSide> values = [buy, sell];

  final String id;

  const FixedSide._(this.id);

  @override
  String toString() => 'FixedSide.$id';

  static FixedSide fromString(String value) => value == null
      ? null
      : values.firstWhere((type) => type.id == value,
          orElse: () => throw new Exception('The type $value does not exist.'));
}

class PaymentType {
  static const regular = const PaymentType._('regular');

  static const priority = const PaymentType._('priority');
  static List<PaymentType> values = [regular, priority];

  final String id;

  const PaymentType._(this.id);

  @override
  String toString() => 'PaymentType.$id';

  static PaymentType fromString(String value) => value == null
      ? null
      : values.firstWhere((type) => type.id == value,
          orElse: () => throw new Exception('The type $value does not exist.'));
}

class RoutingCodeType {
  static const sortCode = const RoutingCodeType._('sort_code');
  static const aba = const RoutingCodeType._('aba');
  static const bsbCode = const RoutingCodeType._('bsb_code');
  static const institutionNo = const RoutingCodeType._('institution_no');
  static const bankCode = const RoutingCodeType._('bank_code');
  static const branchCode = const RoutingCodeType._('branch_code');
  static const clabe = const RoutingCodeType._('clabe');
  static const cnaps = const RoutingCodeType._('cnaps');
  static const ifsc = const RoutingCodeType._('ifsc');
  static List<RoutingCodeType> values = [
    sortCode,
    aba,
    bsbCode,
    institutionNo,
    bankCode,
    branchCode,
    clabe,
    cnaps,
    ifsc,
  ];

  final String id;

  const RoutingCodeType._(this.id);

  @override
  String toString() => 'RoutingCodeType.$id';

  static RoutingCodeType fromString(String value) => value == null
      ? null
      : values.firstWhere((type) => type.id == value,
          orElse: () => throw new Exception('The type $value does not exist.'));
}
