library currency_cloud.rates_api_test;

import 'dart:async';

import 'package:currency_cloud/currency_cloud.dart';
import 'package:mockito/mockito.dart';
import 'package:test/test.dart';

import 'mock_client.dart';
import 'test_data.dart';

main() {
  group('balances', () {
    BalancesApi balancesApi;
    MockClient mockClient;

    setUp(() {
      mockClient = new MockClient();
      balancesApi = new BalancesApi(mockClient);
      balancesApi.client = mockClient;
    });

    test('getting the balance should return the correct response', () async {
      final currency = 'USD';

      final json = getJson(balanceJson);

      final uri = '/balances/USD';

      when(mockClient.get(any, body: anyNamed('body'))).thenAnswer((_) => new Future.value(json));
      final response = await balancesApi.retrieve(currency);
      verify(mockClient.get(uri, body: {})).called(1);
      expect(response, TypeMatcher<Balance>());
      expect(response.id, json['id']);
      // More message tests in balance_test
    });
  });
}
