import 'package:codable/codable.dart';
import 'package:currency_cloud/currency_cloud.dart';
import 'package:decimal/decimal.dart';
import 'package:test/test.dart';

import '../test_data.dart';

main() {
  group('Balance', () {
    test('properly decodes all values', () async {
      final json = getJson(balanceJson).cast<String, String>();
      final archive = KeyedArchive.unarchive(json);
      final balance = Balance()..decode(archive);

      expect(balance.id, json['id']);
      expect(balance.accountId, json['account_id']);
      expect(balance.currency, json['currency']);
      expect(balance.amount, new Decimal.parse(json['amount']));
      expect(balance.createdAt, DateTime.parse(json['created_at']));
      expect(balance.updatedAt, DateTime.parse(json['updated_at']));
    });
  });
}
