import 'package:codable/codable.dart';
import 'package:currency_cloud/currency_cloud.dart';
import 'package:test/test.dart';

import '../test_data.dart';

main() {
  group('Rate', () {
    test('properly decodes all values', () async {
      final json = getJson(rateJson).cast<String, dynamic>();
      final archive = KeyedArchive.unarchive(json);
      final rate = Rate()..decode(archive);

      expect(rate.settlementCutOffTime, dateTimeParse(json['settlement_cut_off_time'] as String));
      expect(rate.currencyPair, json['currency_pair']);
      expect(rate.clientBuyCurrency, json['client_buy_currency']);
      expect(rate.clientSellCurrency, json['client_sell_currency']);
      expect(rate.clientBuyAmount, decimalParse(json['client_buy_amount'] as String));
      expect(rate.clientSellAmount, decimalParse(json['client_sell_amount'] as String));
      expect(rate.fixedSide, FixedSide.fromString(json['fixed_side'] as String));
      expect(rate.clientRate, decimalParse(json['client_rate'] as String));
      expect(rate.partnerRate, decimalParse(json['partner_rate'] as String));
      expect(rate.coreRate, decimalParse(json['core_rate'] as String));
      expect(rate.depositRequired, json['deposit_required']);
      expect(rate.depositAmount, decimalParse(json['deposit_amount'] as String));
      expect(rate.depositCurrency, json['deposit_currency']);
      expect(rate.midMarketRate, decimalParse(json['mid_market_rate'] as String));
    });
  });
}
