library currency_cloud.conversion_api_test;

import 'dart:async';

import 'package:currency_cloud/currency_cloud.dart';
import 'package:decimal/decimal.dart';
import 'package:mockito/mockito.dart';
import 'package:test/test.dart';

import 'mock_client.dart';
import 'test_data.dart';

main() {
  group(('payments api test'), () {
    PaymentsApi paymentsApi;
    MockClient mockClient;

    setUp(() {
      mockClient = new MockClient();
      paymentsApi = new PaymentsApi(mockClient);
      paymentsApi.client = mockClient;
    });

    test('call with all parameters set to valid values', () async {
      final createPayment = new CreatePayment(
        currency: 'GBP',
        beneficiaryId: '9b40b6e7-5d18-42ac-87bc-5c5f774e91ab',
        amount: new Decimal.parse('10.00'),
        reason: 'This is a test payment.',
        reference: 'This is a test reference.',
      );

      final uri = '/payments/create';

      final json = getJson(paymentJson);
      when(mockClient.post(any, body: anyNamed('body'))).thenAnswer((_) => new Future.value(json));
      final conversion = await paymentsApi.create(createPayment);
      verify(mockClient.post(uri, body: anyNamed('body'))).called(1);
      expect(conversion.id, json['id']);
      // More values tested in message tests.
    });
  });
}
